package sk.tuke.kpi.iot2.mqtt;

import org.eclipse.paho.client.mqttv3.IMqttMessageListener;
import org.eclipse.paho.client.mqttv3.MqttClient;
import org.eclipse.paho.client.mqttv3.MqttConnectOptions;
import org.eclipse.paho.client.mqttv3.MqttException;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.nio.charset.StandardCharsets;

public class KpiMqttClient {
    private static final String MQTT_BROKER_URL = "tcp://broker.hivemq.com:1883";

    private MqttClient client;

    public KpiMqttClient() throws MqttException {
        client = new MqttClient(MQTT_BROKER_URL,MqttClient.generateClientId(), new MemoryPersistence() /*Persist QoS messages only to memory not to disk as it is default*/);
        MqttConnectOptions options = new MqttConnectOptions();
        options.setAutomaticReconnect(true);
        client.connect(options);
    }

    public void sendMessage(String topic, String text) throws MqttException {
        client.publish(topic,text.getBytes(StandardCharsets.UTF_8),0,false);
    }

    public void subscribe(String topic, IMqttMessageListener listener) throws MqttException {
        client.subscribe(topic,listener);
    }

}
